<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.6"/>
<title>TIML: appCNNInteropCaffe.hpp File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIML
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.6 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_4f218e5c1c68a8760266841df915118e.html">src</a></li><li class="navelem"><a class="el" href="dir_230ff266809b6c822309e6868f081b10.html">app</a></li><li class="navelem"><a class="el" href="dir_e5b67a8a4144e6ae177326db1accf5e2.html">cnn</a></li><li class="navelem"><a class="el" href="dir_9f7102c8977c4304c9632e12c71e1972.html">interop</a></li><li class="navelem"><a class="el" href="dir_ce1800c9a1795cf1469eaaa9bf86db13.html">caffe</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#enum-members">Enumerations</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">appCNNInteropCaffe.hpp File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &lt;google/protobuf/io/coded_stream.h&gt;</code><br/>
<code>#include &lt;google/protobuf/io/zero_copy_stream_impl.h&gt;</code><br/>
<code>#include &lt;google/protobuf/message.h&gt;</code><br/>
<code>#include &lt;google/protobuf/text_format.h&gt;</code><br/>
<code>#include &lt;fcntl.h&gt;</code><br/>
<code>#include &quot;appCNNInteropCaffeProtobuf.hpp&quot;</code><br/>
<code>#include &quot;<a class="el" href="timl_8h_source.html">timl.h</a>&quot;</code><br/>
</div>
<p><a href="appCNNInteropCaffe_8hpp_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="enum-members"></a>
Enumerations</h2></td></tr>
<tr class="memitem:a6eeaa25df453134c19d4f4611661d837"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><b>appCNNInteropError</b> { <b>ERROR_APP_CNN_INTEROP_ARG</b>, 
<b>ERROR_APP_CNN_INTEROP_READ_FIEL</b>
 }</td></tr>
<tr class="separator:a6eeaa25df453134c19d4f4611661d837"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:ga7052f4eb157d65957ad3fd2332438522"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga7052f4eb157d65957ad3fd2332438522">appCNNInteropCaffeReadProtoFromTextFile</a> (const char *fileName, Message *proto)</td></tr>
<tr class="memdesc:ga7052f4eb157d65957ad3fd2332438522"><td class="mdescLeft">&#160;</td><td class="mdescRight">Caffe read proto from text file.  <a href="group__appCNNInteropCaffe.html#ga7052f4eb157d65957ad3fd2332438522">More...</a><br/></td></tr>
<tr class="separator:ga7052f4eb157d65957ad3fd2332438522"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga622145415a86ef826c3e8017fb478db6"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga622145415a86ef826c3e8017fb478db6">appCNNInteropCaffeReadProtoFromBinaryFile</a> (const char *fileName, Message *proto)</td></tr>
<tr class="memdesc:ga622145415a86ef826c3e8017fb478db6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Caffe read proto from binary file.  <a href="group__appCNNInteropCaffe.html#ga622145415a86ef826c3e8017fb478db6">More...</a><br/></td></tr>
<tr class="separator:ga622145415a86ef826c3e8017fb478db6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga335d05efc7a9d315db56be13fc0af111"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga335d05efc7a9d315db56be13fc0af111">appCNNInteropCaffeFlipMatrixFloat</a> (float *a, int m, int n)</td></tr>
<tr class="memdesc:ga335d05efc7a9d315db56be13fc0af111"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flip a matrix.  <a href="group__appCNNInteropCaffe.html#ga335d05efc7a9d315db56be13fc0af111">More...</a><br/></td></tr>
<tr class="separator:ga335d05efc7a9d315db56be13fc0af111"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga4d2f15bd3e322f77cbc47edf00f9ef36"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga4d2f15bd3e322f77cbc47edf00f9ef36">appCNNInteropCaffeFlipKernelMatrix</a> (float *kernel, int kernelRow, int kernelCol, int inputChannel, int outputChannel)</td></tr>
<tr class="memdesc:ga4d2f15bd3e322f77cbc47edf00f9ef36"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flip the kernels.  <a href="group__appCNNInteropCaffe.html#ga4d2f15bd3e322f77cbc47edf00f9ef36">More...</a><br/></td></tr>
<tr class="separator:ga4d2f15bd3e322f77cbc47edf00f9ef36"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga9a4b55d7ec059ee00c3c6b6d5743f9f7"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga9a4b55d7ec059ee00c3c6b6d5743f9f7">appCNNInteropCaffeFillBlockDiagonalMatrix</a> (float *a, int M, int N, int group, float *b)</td></tr>
<tr class="memdesc:ga9a4b55d7ec059ee00c3c6b6d5743f9f7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Fill a block diagonal matrix.  <a href="group__appCNNInteropCaffe.html#ga9a4b55d7ec059ee00c3c6b6d5743f9f7">More...</a><br/></td></tr>
<tr class="separator:ga9a4b55d7ec059ee00c3c6b6d5743f9f7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga630a9d1314c2151e7193de73a714b789"><td class="memItemLeft" align="right" valign="top">timlUtilActivationType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga630a9d1314c2151e7193de73a714b789">appCNNInteropCaffeNonlinearTypeConvert</a> (LayerParameter_LayerType type)</td></tr>
<tr class="memdesc:ga630a9d1314c2151e7193de73a714b789"><td class="mdescLeft">&#160;</td><td class="mdescRight">Caffe nonlinear layer type conversion.  <a href="group__appCNNInteropCaffe.html#ga630a9d1314c2151e7193de73a714b789">More...</a><br/></td></tr>
<tr class="separator:ga630a9d1314c2151e7193de73a714b789"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga3752b452e61029bc03d4f10b95d0a861"><td class="memItemLeft" align="right" valign="top">timlCNNLayerType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga3752b452e61029bc03d4f10b95d0a861">appCNNInteropCaffeLayerTypeConvert</a> (LayerParameter_LayerType type)</td></tr>
<tr class="memdesc:ga3752b452e61029bc03d4f10b95d0a861"><td class="mdescLeft">&#160;</td><td class="mdescRight">Caffe to TIML CNN layer type conversion.  <a href="group__appCNNInteropCaffe.html#ga3752b452e61029bc03d4f10b95d0a861">More...</a><br/></td></tr>
<tr class="separator:ga3752b452e61029bc03d4f10b95d0a861"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga3106ebef164cd39f0bc864c59c2c0a45"><td class="memItemLeft" align="right" valign="top">timlCNNPoolingType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga3106ebef164cd39f0bc864c59c2c0a45">appCNNInteropCaffePoolingTypeConvert</a> (PoolingParameter_PoolMethod method)</td></tr>
<tr class="memdesc:ga3106ebef164cd39f0bc864c59c2c0a45"><td class="mdescLeft">&#160;</td><td class="mdescRight">Caffe pooling type conversion.  <a href="group__appCNNInteropCaffe.html#ga3106ebef164cd39f0bc864c59c2c0a45">More...</a><br/></td></tr>
<tr class="separator:ga3106ebef164cd39f0bc864c59c2c0a45"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga2ce06f0ef11d677b3087a59857797335"><td class="memItemLeft" align="right" valign="top"><a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga2ce06f0ef11d677b3087a59857797335">appCNNInteropCaffeConvert</a> (const char *netStructurePrototxtFileName, const char *netParamPrototxtFileName)</td></tr>
<tr class="memdesc:ga2ce06f0ef11d677b3087a59857797335"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert Caffe to TIML CNN.  <a href="group__appCNNInteropCaffe.html#ga2ce06f0ef11d677b3087a59857797335">More...</a><br/></td></tr>
<tr class="separator:ga2ce06f0ef11d677b3087a59857797335"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga17ffed596b6ee6d57574915f1eaaaf23"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga17ffed596b6ee6d57574915f1eaaaf23">appCNNInteropCaffeConvLayerConvert</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, LayerParameter layerStructure, LayerParameter layerParam)</td></tr>
<tr class="memdesc:ga17ffed596b6ee6d57574915f1eaaaf23"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert Caffe conv layer.  <a href="group__appCNNInteropCaffe.html#ga17ffed596b6ee6d57574915f1eaaaf23">More...</a><br/></td></tr>
<tr class="separator:ga17ffed596b6ee6d57574915f1eaaaf23"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga9dfa0736763aefc3d820ca27e7a19882"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga9dfa0736763aefc3d820ca27e7a19882">appCNNInteropCaffeConvLayerPermuteKernel</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer)</td></tr>
<tr class="memdesc:ga9dfa0736763aefc3d820ca27e7a19882"><td class="mdescLeft">&#160;</td><td class="mdescRight">Change the kernel from BGR squence to RGB.  <a href="group__appCNNInteropCaffe.html#ga9dfa0736763aefc3d820ca27e7a19882">More...</a><br/></td></tr>
<tr class="separator:ga9dfa0736763aefc3d820ca27e7a19882"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gae61e927bb0b0fd6cca3dd1a45f8a1e62"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#gae61e927bb0b0fd6cca3dd1a45f8a1e62">appCNNInteropCaffePoolingLayerConvert</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, LayerParameter layerStructure, LayerParameter layerParam)</td></tr>
<tr class="memdesc:gae61e927bb0b0fd6cca3dd1a45f8a1e62"><td class="mdescLeft">&#160;</td><td class="mdescRight">Caffe pooling layer conversion.  <a href="group__appCNNInteropCaffe.html#gae61e927bb0b0fd6cca3dd1a45f8a1e62">More...</a><br/></td></tr>
<tr class="separator:gae61e927bb0b0fd6cca3dd1a45f8a1e62"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga7ac38ac27f861867ee84e038428d2139"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga7ac38ac27f861867ee84e038428d2139">appCNNInteropCaffeNormLayerConvert</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, LayerParameter layerStructure, LayerParameter layerParam)</td></tr>
<tr class="memdesc:ga7ac38ac27f861867ee84e038428d2139"><td class="mdescLeft">&#160;</td><td class="mdescRight">Caffe norm layer conversion.  <a href="group__appCNNInteropCaffe.html#ga7ac38ac27f861867ee84e038428d2139">More...</a><br/></td></tr>
<tr class="separator:ga7ac38ac27f861867ee84e038428d2139"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga53805074229f6d101a0b3c91dce8216b"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#ga53805074229f6d101a0b3c91dce8216b">appCNNInteropCaffeLinearLayerConvert</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, LayerParameter layerStructure, LayerParameter layerParam)</td></tr>
<tr class="memdesc:ga53805074229f6d101a0b3c91dce8216b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Caffe linear layer conversion.  <a href="group__appCNNInteropCaffe.html#ga53805074229f6d101a0b3c91dce8216b">More...</a><br/></td></tr>
<tr class="separator:ga53805074229f6d101a0b3c91dce8216b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gab913f62c0b33ce7bc646d2877e9fb748"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#gab913f62c0b33ce7bc646d2877e9fb748">appCNNInteropCaffeNonlinearLayerConvert</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, LayerParameter layerStructure, LayerParameter layerParam)</td></tr>
<tr class="memdesc:gab913f62c0b33ce7bc646d2877e9fb748"><td class="mdescLeft">&#160;</td><td class="mdescRight">Caffe nonlinear layer conversion.  <a href="group__appCNNInteropCaffe.html#gab913f62c0b33ce7bc646d2877e9fb748">More...</a><br/></td></tr>
<tr class="separator:gab913f62c0b33ce7bc646d2877e9fb748"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaf982a0ff86bbbfffaa342f80b3f46cb5"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#gaf982a0ff86bbbfffaa342f80b3f46cb5">appCNNInteropCaffeDropoutLayerConvert</a> (<a class="el" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn, LayerParameter layerStructure, LayerParameter layerParam)</td></tr>
<tr class="memdesc:gaf982a0ff86bbbfffaa342f80b3f46cb5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Caffe dropout layer conversion.  <a href="group__appCNNInteropCaffe.html#gaf982a0ff86bbbfffaa342f80b3f46cb5">More...</a><br/></td></tr>
<tr class="separator:gaf982a0ff86bbbfffaa342f80b3f46cb5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gab530bd6ef77e6850fb50355ce85f8ff8"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#gab530bd6ef77e6850fb50355ce85f8ff8">appCNNInteropCaffeReadMean</a> (<a class="el" href="struct__timlCNNLayer__.html">timlCNNLayer</a> *layer, const char *fileName)</td></tr>
<tr class="memdesc:gab530bd6ef77e6850fb50355ce85f8ff8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read Caffe mean binary file.  <a href="group__appCNNInteropCaffe.html#gab530bd6ef77e6850fb50355ce85f8ff8">More...</a><br/></td></tr>
<tr class="separator:gab530bd6ef77e6850fb50355ce85f8ff8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaa86fc855715a800c4e27a31159c39207"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__appCNNInteropCaffe.html#gaa86fc855715a800c4e27a31159c39207">appCNNInteropCaffePermuteMean</a> (float *mean, int row, int col, int channel)</td></tr>
<tr class="memdesc:gaa86fc855715a800c4e27a31159c39207"><td class="mdescLeft">&#160;</td><td class="mdescRight">Permute the mean in the input layer from BGR sequence to RGB.  <a href="group__appCNNInteropCaffe.html#gaa86fc855715a800c4e27a31159c39207">More...</a><br/></td></tr>
<tr class="separator:gaa86fc855715a800c4e27a31159c39207"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Mar 20 2015 11:26:08 for TIML by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.6
</small></address>
</body>
</html>
